{-# OPTIONS_GHC -Wall #-}
{-# Language ForeignFunctionInterface #-}

module Casadi.Wrappers.CToolsImports where

import Foreign.C.Types
import Foreign.Ptr ( Ptr )

import Casadi.MarshalTypes

--------------------------- ("int","CInt",Nothing,["Int","Bool"]) -----------------------------------
foreign import ccall unsafe "hs_new_vec_int" c_newVecCInt
  :: Ptr CInt -> CInt -> IO (Ptr (CppVec CInt))
foreign import ccall unsafe "hs_delete_vec_int" c_deleteVecCInt
  :: Ptr (CppVec CInt) -> IO ()
foreign import ccall unsafe "hs_copy_vec_int" c_copyVecCInt
  :: Ptr (CppVec CInt) -> Ptr CInt -> IO ()
foreign import ccall unsafe "hs_size_vec_int" c_sizeVecCInt
  :: Ptr (CppVec CInt) -> IO CInt

--------------------------- ("voidp","VoidP",Just "(Ptr a)",[]) -----------------------------------
foreign import ccall unsafe "hs_new_vec_voidp" c_newVecVoidP
  :: Ptr (Ptr a) -> CInt -> IO (Ptr (CppVec (Ptr a)))
foreign import ccall unsafe "hs_delete_vec_voidp" c_deleteVecVoidP
  :: Ptr (CppVec (Ptr a)) -> IO ()
foreign import ccall unsafe "hs_copy_vec_voidp" c_copyVecVoidP
  :: Ptr (CppVec (Ptr a)) -> Ptr (Ptr a) -> IO ()
foreign import ccall unsafe "hs_size_vec_voidp" c_sizeVecVoidP
  :: Ptr (CppVec (Ptr a)) -> IO CInt

--------------------------- ("uchar","CUChar",Nothing,[]) -----------------------------------
foreign import ccall unsafe "hs_new_vec_uchar" c_newVecCUChar
  :: Ptr CUChar -> CInt -> IO (Ptr (CppVec CUChar))
foreign import ccall unsafe "hs_delete_vec_uchar" c_deleteVecCUChar
  :: Ptr (CppVec CUChar) -> IO ()
foreign import ccall unsafe "hs_copy_vec_uchar" c_copyVecCUChar
  :: Ptr (CppVec CUChar) -> Ptr CUChar -> IO ()
foreign import ccall unsafe "hs_size_vec_uchar" c_sizeVecCUChar
  :: Ptr (CppVec CUChar) -> IO CInt

--------------------------- ("double","CDouble",Nothing,["Double"]) -----------------------------------
foreign import ccall unsafe "hs_new_vec_double" c_newVecCDouble
  :: Ptr CDouble -> CInt -> IO (Ptr (CppVec CDouble))
foreign import ccall unsafe "hs_delete_vec_double" c_deleteVecCDouble
  :: Ptr (CppVec CDouble) -> IO ()
foreign import ccall unsafe "hs_copy_vec_double" c_copyVecCDouble
  :: Ptr (CppVec CDouble) -> Ptr CDouble -> IO ()
foreign import ccall unsafe "hs_size_vec_double" c_sizeVecCDouble
  :: Ptr (CppVec CDouble) -> IO CInt
