{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.CasadiMeta
       (
         CasadiMeta,
         CasadiMetaClass(..),
         casadiMeta_getBuildType,
         casadiMeta_getCompiler,
         casadiMeta_getCompilerFlags,
         casadiMeta_getCompilerId,
         casadiMeta_getFeatureList,
         casadiMeta_getGitDescribe,
         casadiMeta_getGitRevision,
         casadiMeta_getVersion,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

-- direct wrapper
foreign import ccall unsafe "CasADi__CasadiMeta__getVersion" c_CasADi__CasadiMeta__getVersion
  :: IO (Ptr StdString')
casADi__CasadiMeta__getVersion
  :: IO String
casADi__CasadiMeta__getVersion  =
  c_CasADi__CasadiMeta__getVersion  >>= wrapReturn

-- classy wrapper
casadiMeta_getVersion :: IO String
casadiMeta_getVersion = casADi__CasadiMeta__getVersion


-- direct wrapper
foreign import ccall unsafe "CasADi__CasadiMeta__getGitRevision" c_CasADi__CasadiMeta__getGitRevision
  :: IO (Ptr StdString')
casADi__CasadiMeta__getGitRevision
  :: IO String
casADi__CasadiMeta__getGitRevision  =
  c_CasADi__CasadiMeta__getGitRevision  >>= wrapReturn

-- classy wrapper
casadiMeta_getGitRevision :: IO String
casadiMeta_getGitRevision = casADi__CasadiMeta__getGitRevision


-- direct wrapper
foreign import ccall unsafe "CasADi__CasadiMeta__getGitDescribe" c_CasADi__CasadiMeta__getGitDescribe
  :: IO (Ptr StdString')
casADi__CasadiMeta__getGitDescribe
  :: IO String
casADi__CasadiMeta__getGitDescribe  =
  c_CasADi__CasadiMeta__getGitDescribe  >>= wrapReturn

-- classy wrapper
casadiMeta_getGitDescribe :: IO String
casadiMeta_getGitDescribe = casADi__CasadiMeta__getGitDescribe


-- direct wrapper
foreign import ccall unsafe "CasADi__CasadiMeta__getFeatureList" c_CasADi__CasadiMeta__getFeatureList
  :: IO (Ptr StdString')
casADi__CasadiMeta__getFeatureList
  :: IO String
casADi__CasadiMeta__getFeatureList  =
  c_CasADi__CasadiMeta__getFeatureList  >>= wrapReturn

-- classy wrapper
casadiMeta_getFeatureList :: IO String
casadiMeta_getFeatureList = casADi__CasadiMeta__getFeatureList


-- direct wrapper
foreign import ccall unsafe "CasADi__CasadiMeta__getBuildType" c_CasADi__CasadiMeta__getBuildType
  :: IO (Ptr StdString')
casADi__CasadiMeta__getBuildType
  :: IO String
casADi__CasadiMeta__getBuildType  =
  c_CasADi__CasadiMeta__getBuildType  >>= wrapReturn

-- classy wrapper
casadiMeta_getBuildType :: IO String
casadiMeta_getBuildType = casADi__CasadiMeta__getBuildType


-- direct wrapper
foreign import ccall unsafe "CasADi__CasadiMeta__getCompilerId" c_CasADi__CasadiMeta__getCompilerId
  :: IO (Ptr StdString')
casADi__CasadiMeta__getCompilerId
  :: IO String
casADi__CasadiMeta__getCompilerId  =
  c_CasADi__CasadiMeta__getCompilerId  >>= wrapReturn

-- classy wrapper
casadiMeta_getCompilerId :: IO String
casadiMeta_getCompilerId = casADi__CasadiMeta__getCompilerId


-- direct wrapper
foreign import ccall unsafe "CasADi__CasadiMeta__getCompiler" c_CasADi__CasadiMeta__getCompiler
  :: IO (Ptr StdString')
casADi__CasadiMeta__getCompiler
  :: IO String
casADi__CasadiMeta__getCompiler  =
  c_CasADi__CasadiMeta__getCompiler  >>= wrapReturn

-- classy wrapper
casadiMeta_getCompiler :: IO String
casadiMeta_getCompiler = casADi__CasadiMeta__getCompiler


-- direct wrapper
foreign import ccall unsafe "CasADi__CasadiMeta__getCompilerFlags" c_CasADi__CasadiMeta__getCompilerFlags
  :: IO (Ptr StdString')
casADi__CasadiMeta__getCompilerFlags
  :: IO String
casADi__CasadiMeta__getCompilerFlags  =
  c_CasADi__CasadiMeta__getCompilerFlags  >>= wrapReturn

-- classy wrapper
casadiMeta_getCompilerFlags :: IO String
casadiMeta_getCompilerFlags = casADi__CasadiMeta__getCompilerFlags

