{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.CustomEvaluate
       (
         CustomEvaluate,
         CustomEvaluateClass(..),
         customEvaluate,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.Classes.PrintableObject
import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show CustomEvaluate where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__CustomEvaluate__CustomEvaluate" c_CasADi__CustomEvaluate__CustomEvaluate
  :: IO (Ptr CustomEvaluate')
casADi__CustomEvaluate__CustomEvaluate
  :: IO CustomEvaluate
casADi__CustomEvaluate__CustomEvaluate  =
  c_CasADi__CustomEvaluate__CustomEvaluate  >>= wrapReturn

-- classy wrapper
{-|
>>  CasADi::CustomEvaluate::CustomEvaluate()
>------------------------------------------------------------------------
>
>Default constructor.
>
>>  CasADi::CustomEvaluate::CustomEvaluate(CustomEvaluateCPtr ptr)
>------------------------------------------------------------------------
>
>Construct from C pointer.
-}
customEvaluate :: IO CustomEvaluate
customEvaluate = casADi__CustomEvaluate__CustomEvaluate

