{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.IOInterfaceFX
       (
         IOInterfaceFX,
         IOInterfaceFXClass(..),
         ioInterfaceFX_getInputScheme,
         ioInterfaceFX_getNumInputs,
         ioInterfaceFX_getNumOutputs,
         ioInterfaceFX_getOutputScheme,
         ioInterfaceFX_input,
         ioInterfaceFX_input',
         ioInterfaceFX_input'',
         ioInterfaceFX_inputSchemeEntry,
         ioInterfaceFX_output,
         ioInterfaceFX_output',
         ioInterfaceFX_output'',
         ioInterfaceFX_outputSchemeEntry,
         ioInterfaceFX_schemeEntry,
         ioInterfaceFX_setInput,
         ioInterfaceFX_setInput',
         ioInterfaceFX_setInput''',
         ioInterfaceFX_setInput'''',
         ioInterfaceFX_setInput''''',
         ioInterfaceFX_setInput'''''',
         ioInterfaceFX_setInput''''''',
         ioInterfaceFX_setInput'''''''',
         ioInterfaceFX_setOutput,
         ioInterfaceFX_setOutput',
         ioInterfaceFX_setOutput'',
         ioInterfaceFX_setOutput''',
         ioInterfaceFX_setOutput'''',
         ioInterfaceFX_setOutput''''',
         ioInterfaceFX_setOutput'''''',
         ioInterfaceFX_setOutput''''''',
         ioInterfaceFX_setOutput'''''''',
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___input" c_CasADi__IOInterface_CasADi__FX___input
  :: Ptr IOInterfaceFX' -> CInt -> IO (Ptr DMatrix')
casADi__IOInterface_CasADi__FX___input
  :: IOInterfaceFX -> Int -> IO DMatrix
casADi__IOInterface_CasADi__FX___input x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___input x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>Access input argument.
-}
ioInterfaceFX_input :: IOInterfaceFXClass a => a -> Int -> IO DMatrix
ioInterfaceFX_input x = casADi__IOInterface_CasADi__FX___input (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___input_TIC" c_CasADi__IOInterface_CasADi__FX___input_TIC
  :: Ptr IOInterfaceFX' -> IO (Ptr DMatrix')
casADi__IOInterface_CasADi__FX___input'
  :: IOInterfaceFX -> IO DMatrix
casADi__IOInterface_CasADi__FX___input' x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__IOInterface_CasADi__FX___input_TIC x0' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_input' :: IOInterfaceFXClass a => a -> IO DMatrix
ioInterfaceFX_input' x = casADi__IOInterface_CasADi__FX___input' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___input_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___input_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr StdString' -> IO (Ptr DMatrix')
casADi__IOInterface_CasADi__FX___input''
  :: IOInterfaceFX -> String -> IO DMatrix
casADi__IOInterface_CasADi__FX___input'' x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___input_TIC_TIC x0' x1' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_input'' :: IOInterfaceFXClass a => a -> String -> IO DMatrix
ioInterfaceFX_input'' x = casADi__IOInterface_CasADi__FX___input'' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___output" c_CasADi__IOInterface_CasADi__FX___output
  :: Ptr IOInterfaceFX' -> CInt -> IO (Ptr DMatrix')
casADi__IOInterface_CasADi__FX___output
  :: IOInterfaceFX -> Int -> IO DMatrix
casADi__IOInterface_CasADi__FX___output x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___output x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>Access output argument.
-}
ioInterfaceFX_output :: IOInterfaceFXClass a => a -> Int -> IO DMatrix
ioInterfaceFX_output x = casADi__IOInterface_CasADi__FX___output (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___output_TIC" c_CasADi__IOInterface_CasADi__FX___output_TIC
  :: Ptr IOInterfaceFX' -> IO (Ptr DMatrix')
casADi__IOInterface_CasADi__FX___output'
  :: IOInterfaceFX -> IO DMatrix
casADi__IOInterface_CasADi__FX___output' x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__IOInterface_CasADi__FX___output_TIC x0' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_output' :: IOInterfaceFXClass a => a -> IO DMatrix
ioInterfaceFX_output' x = casADi__IOInterface_CasADi__FX___output' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___output_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___output_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr StdString' -> IO (Ptr DMatrix')
casADi__IOInterface_CasADi__FX___output''
  :: IOInterfaceFX -> String -> IO DMatrix
casADi__IOInterface_CasADi__FX___output'' x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___output_TIC_TIC x0' x1' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_output'' :: IOInterfaceFXClass a => a -> String -> IO DMatrix
ioInterfaceFX_output'' x = casADi__IOInterface_CasADi__FX___output'' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___getNumInputs" c_CasADi__IOInterface_CasADi__FX___getNumInputs
  :: Ptr IOInterfaceFX' -> IO CInt
casADi__IOInterface_CasADi__FX___getNumInputs
  :: IOInterfaceFX -> IO Int
casADi__IOInterface_CasADi__FX___getNumInputs x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__IOInterface_CasADi__FX___getNumInputs x0' >>= wrapReturn

-- classy wrapper
{-|
>Get the number of function inputs.
-}
ioInterfaceFX_getNumInputs :: IOInterfaceFXClass a => a -> IO Int
ioInterfaceFX_getNumInputs x = casADi__IOInterface_CasADi__FX___getNumInputs (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___getNumOutputs" c_CasADi__IOInterface_CasADi__FX___getNumOutputs
  :: Ptr IOInterfaceFX' -> IO CInt
casADi__IOInterface_CasADi__FX___getNumOutputs
  :: IOInterfaceFX -> IO Int
casADi__IOInterface_CasADi__FX___getNumOutputs x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__IOInterface_CasADi__FX___getNumOutputs x0' >>= wrapReturn

-- classy wrapper
{-|
>Get the number of function outputs.
-}
ioInterfaceFX_getNumOutputs :: IOInterfaceFXClass a => a -> IO Int
ioInterfaceFX_getNumOutputs x = casADi__IOInterface_CasADi__FX___getNumOutputs (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___getInputScheme" c_CasADi__IOInterface_CasADi__FX___getInputScheme
  :: Ptr IOInterfaceFX' -> IO (Ptr IOScheme')
casADi__IOInterface_CasADi__FX___getInputScheme
  :: IOInterfaceFX -> IO IOScheme
casADi__IOInterface_CasADi__FX___getInputScheme x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__IOInterface_CasADi__FX___getInputScheme x0' >>= wrapReturn

-- classy wrapper
{-|
>Get input scheme.
-}
ioInterfaceFX_getInputScheme :: IOInterfaceFXClass a => a -> IO IOScheme
ioInterfaceFX_getInputScheme x = casADi__IOInterface_CasADi__FX___getInputScheme (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___getOutputScheme" c_CasADi__IOInterface_CasADi__FX___getOutputScheme
  :: Ptr IOInterfaceFX' -> IO (Ptr IOScheme')
casADi__IOInterface_CasADi__FX___getOutputScheme
  :: IOInterfaceFX -> IO IOScheme
casADi__IOInterface_CasADi__FX___getOutputScheme x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__IOInterface_CasADi__FX___getOutputScheme x0' >>= wrapReturn

-- classy wrapper
{-|
>Get output scheme.
-}
ioInterfaceFX_getOutputScheme :: IOInterfaceFXClass a => a -> IO IOScheme
ioInterfaceFX_getOutputScheme x = casADi__IOInterface_CasADi__FX___getOutputScheme (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___inputSchemeEntry" c_CasADi__IOInterface_CasADi__FX___inputSchemeEntry
  :: Ptr IOInterfaceFX' -> Ptr StdString' -> IO CInt
casADi__IOInterface_CasADi__FX___inputSchemeEntry
  :: IOInterfaceFX -> String -> IO Int
casADi__IOInterface_CasADi__FX___inputSchemeEntry x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___inputSchemeEntry x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>Find the index for a string describing a particular entry of an input scheme
>example: schemeEntry("x_opt") -> returns NLP_SOLVER_X if FXInternal
>adheres to SCHEME_NLPINput.
-}
ioInterfaceFX_inputSchemeEntry :: IOInterfaceFXClass a => a -> String -> IO Int
ioInterfaceFX_inputSchemeEntry x = casADi__IOInterface_CasADi__FX___inputSchemeEntry (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___outputSchemeEntry" c_CasADi__IOInterface_CasADi__FX___outputSchemeEntry
  :: Ptr IOInterfaceFX' -> Ptr StdString' -> IO CInt
casADi__IOInterface_CasADi__FX___outputSchemeEntry
  :: IOInterfaceFX -> String -> IO Int
casADi__IOInterface_CasADi__FX___outputSchemeEntry x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___outputSchemeEntry x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>Find the index for a string describing a particular entry of an output
>scheme example: schemeEntry("x_opt") -> returns NLP_SOLVER_X if FXInternal
>adheres to SCHEME_NLPINput.
-}
ioInterfaceFX_outputSchemeEntry :: IOInterfaceFXClass a => a -> String -> IO Int
ioInterfaceFX_outputSchemeEntry x = casADi__IOInterface_CasADi__FX___outputSchemeEntry (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___schemeEntry" c_CasADi__IOInterface_CasADi__FX___schemeEntry
  :: Ptr IOInterfaceFX' -> Ptr IOScheme' -> Ptr StdString' -> CInt -> IO CInt
casADi__IOInterface_CasADi__FX___schemeEntry
  :: IOInterfaceFX -> IOScheme -> String -> Bool -> IO Int
casADi__IOInterface_CasADi__FX___schemeEntry x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  c_CasADi__IOInterface_CasADi__FX___schemeEntry x0' x1' x2' x3' >>= wrapReturn

-- classy wrapper
{-|
>Find the index for a string describing a particular entry of a scheme
>example: schemeEntry("x_opt") -> returns NLP_SOLVER_X if FXInternal
>adheres to SCHEME_NLPINput.
-}
ioInterfaceFX_schemeEntry :: IOInterfaceFXClass a => a -> IOScheme -> String -> Bool -> IO Int
ioInterfaceFX_schemeEntry x = casADi__IOInterface_CasADi__FX___schemeEntry (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setInput" c_CasADi__IOInterface_CasADi__FX___setInput
  :: Ptr IOInterfaceFX' -> CDouble -> CInt -> IO ()
casADi__IOInterface_CasADi__FX___setInput
  :: IOInterfaceFX -> Double -> Int -> IO ()
casADi__IOInterface_CasADi__FX___setInput x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  c_CasADi__IOInterface_CasADi__FX___setInput x0' x1' x2' >>= wrapReturn

-- classy wrapper
{-|
>Reads in the input argument from val. T can be double&, double*,
>std::vector<double>&, Matrix<double> &  Assumes a properly allocated val. .
-}
ioInterfaceFX_setInput :: IOInterfaceFXClass a => a -> Double -> Int -> IO ()
ioInterfaceFX_setInput x = casADi__IOInterface_CasADi__FX___setInput (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setInput_TIC" c_CasADi__IOInterface_CasADi__FX___setInput_TIC
  :: Ptr IOInterfaceFX' -> CDouble -> IO ()
casADi__IOInterface_CasADi__FX___setInput'
  :: IOInterfaceFX -> Double -> IO ()
casADi__IOInterface_CasADi__FX___setInput' x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___setInput_TIC x0' x1' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setInput' :: IOInterfaceFXClass a => a -> Double -> IO ()
ioInterfaceFX_setInput' x = casADi__IOInterface_CasADi__FX___setInput' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setOutput" c_CasADi__IOInterface_CasADi__FX___setOutput
  :: Ptr IOInterfaceFX' -> CDouble -> CInt -> IO ()
casADi__IOInterface_CasADi__FX___setOutput
  :: IOInterfaceFX -> Double -> Int -> IO ()
casADi__IOInterface_CasADi__FX___setOutput x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  c_CasADi__IOInterface_CasADi__FX___setOutput x0' x1' x2' >>= wrapReturn

-- classy wrapper
{-|
>Reads in the output argument from val. T can be double&, double*,
>std::vector<double>&, Matrix<double> &  Assumes a properly allocated val. .
-}
ioInterfaceFX_setOutput :: IOInterfaceFXClass a => a -> Double -> Int -> IO ()
ioInterfaceFX_setOutput x = casADi__IOInterface_CasADi__FX___setOutput (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setOutput_TIC" c_CasADi__IOInterface_CasADi__FX___setOutput_TIC
  :: Ptr IOInterfaceFX' -> CDouble -> IO ()
casADi__IOInterface_CasADi__FX___setOutput'
  :: IOInterfaceFX -> Double -> IO ()
casADi__IOInterface_CasADi__FX___setOutput' x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___setOutput_TIC x0' x1' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setOutput' :: IOInterfaceFXClass a => a -> Double -> IO ()
ioInterfaceFX_setOutput' x = casADi__IOInterface_CasADi__FX___setOutput' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC
  :: Ptr IOInterfaceFX' -> CDouble -> Ptr StdString' -> IO ()
casADi__IOInterface_CasADi__FX___setOutput''
  :: IOInterfaceFX -> Double -> String -> IO ()
casADi__IOInterface_CasADi__FX___setOutput'' x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC x0' x1' x2' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setOutput'' :: IOInterfaceFXClass a => a -> Double -> String -> IO ()
ioInterfaceFX_setOutput'' x = casADi__IOInterface_CasADi__FX___setOutput'' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr (CppVec CDouble) -> CInt -> IO ()
casADi__IOInterface_CasADi__FX___setInput'''
  :: IOInterfaceFX -> Vector Double -> Int -> IO ()
casADi__IOInterface_CasADi__FX___setInput''' x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC x0' x1' x2' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setInput''' :: IOInterfaceFXClass a => a -> Vector Double -> Int -> IO ()
ioInterfaceFX_setInput''' x = casADi__IOInterface_CasADi__FX___setInput''' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr (CppVec CDouble) -> IO ()
casADi__IOInterface_CasADi__FX___setInput''''
  :: IOInterfaceFX -> Vector Double -> IO ()
casADi__IOInterface_CasADi__FX___setInput'''' x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC x0' x1' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setInput'''' :: IOInterfaceFXClass a => a -> Vector Double -> IO ()
ioInterfaceFX_setInput'''' x = casADi__IOInterface_CasADi__FX___setInput'''' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr (CppVec CDouble) -> CInt -> IO ()
casADi__IOInterface_CasADi__FX___setOutput'''
  :: IOInterfaceFX -> Vector Double -> Int -> IO ()
casADi__IOInterface_CasADi__FX___setOutput''' x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC x0' x1' x2' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setOutput''' :: IOInterfaceFXClass a => a -> Vector Double -> Int -> IO ()
ioInterfaceFX_setOutput''' x = casADi__IOInterface_CasADi__FX___setOutput''' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr (CppVec CDouble) -> IO ()
casADi__IOInterface_CasADi__FX___setOutput''''
  :: IOInterfaceFX -> Vector Double -> IO ()
casADi__IOInterface_CasADi__FX___setOutput'''' x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC x0' x1' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setOutput'''' :: IOInterfaceFXClass a => a -> Vector Double -> IO ()
ioInterfaceFX_setOutput'''' x = casADi__IOInterface_CasADi__FX___setOutput'''' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr (CppVec CDouble) -> Ptr StdString' -> IO ()
casADi__IOInterface_CasADi__FX___setInput'''''
  :: IOInterfaceFX -> Vector Double -> String -> IO ()
casADi__IOInterface_CasADi__FX___setInput''''' x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC x0' x1' x2' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setInput''''' :: IOInterfaceFXClass a => a -> Vector Double -> String -> IO ()
ioInterfaceFX_setInput''''' x = casADi__IOInterface_CasADi__FX___setInput''''' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr (CppVec CDouble) -> Ptr StdString' -> IO ()
casADi__IOInterface_CasADi__FX___setOutput'''''
  :: IOInterfaceFX -> Vector Double -> String -> IO ()
casADi__IOInterface_CasADi__FX___setOutput''''' x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC x0' x1' x2' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setOutput''''' :: IOInterfaceFXClass a => a -> Vector Double -> String -> IO ()
ioInterfaceFX_setOutput''''' x = casADi__IOInterface_CasADi__FX___setOutput''''' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr DMatrix' -> CInt -> IO ()
casADi__IOInterface_CasADi__FX___setInput''''''
  :: IOInterfaceFX -> DMatrix -> Int -> IO ()
casADi__IOInterface_CasADi__FX___setInput'''''' x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC_TIC x0' x1' x2' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setInput'''''' :: IOInterfaceFXClass a => a -> DMatrix -> Int -> IO ()
ioInterfaceFX_setInput'''''' x = casADi__IOInterface_CasADi__FX___setInput'''''' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr DMatrix' -> IO ()
casADi__IOInterface_CasADi__FX___setInput'''''''
  :: IOInterfaceFX -> DMatrix -> IO ()
casADi__IOInterface_CasADi__FX___setInput''''''' x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC_TIC_TIC x0' x1' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setInput''''''' :: IOInterfaceFXClass a => a -> DMatrix -> IO ()
ioInterfaceFX_setInput''''''' x = casADi__IOInterface_CasADi__FX___setInput''''''' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr DMatrix' -> CInt -> IO ()
casADi__IOInterface_CasADi__FX___setOutput''''''
  :: IOInterfaceFX -> DMatrix -> Int -> IO ()
casADi__IOInterface_CasADi__FX___setOutput'''''' x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC_TIC x0' x1' x2' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setOutput'''''' :: IOInterfaceFXClass a => a -> DMatrix -> Int -> IO ()
ioInterfaceFX_setOutput'''''' x = casADi__IOInterface_CasADi__FX___setOutput'''''' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr DMatrix' -> IO ()
casADi__IOInterface_CasADi__FX___setOutput'''''''
  :: IOInterfaceFX -> DMatrix -> IO ()
casADi__IOInterface_CasADi__FX___setOutput''''''' x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC_TIC_TIC x0' x1' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setOutput''''''' :: IOInterfaceFXClass a => a -> DMatrix -> IO ()
ioInterfaceFX_setOutput''''''' x = casADi__IOInterface_CasADi__FX___setOutput''''''' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr DMatrix' -> Ptr StdString' -> IO ()
casADi__IOInterface_CasADi__FX___setInput''''''''
  :: IOInterfaceFX -> DMatrix -> String -> IO ()
casADi__IOInterface_CasADi__FX___setInput'''''''' x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  c_CasADi__IOInterface_CasADi__FX___setInput_TIC_TIC_TIC_TIC_TIC_TIC_TIC_TIC x0' x1' x2' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setInput'''''''' :: IOInterfaceFXClass a => a -> DMatrix -> String -> IO ()
ioInterfaceFX_setInput'''''''' x = casADi__IOInterface_CasADi__FX___setInput'''''''' (castIOInterfaceFX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC_TIC_TIC_TIC" c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC_TIC_TIC_TIC
  :: Ptr IOInterfaceFX' -> Ptr DMatrix' -> Ptr StdString' -> IO ()
casADi__IOInterface_CasADi__FX___setOutput''''''''
  :: IOInterfaceFX -> DMatrix -> String -> IO ()
casADi__IOInterface_CasADi__FX___setOutput'''''''' x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  c_CasADi__IOInterface_CasADi__FX___setOutput_TIC_TIC_TIC_TIC_TIC_TIC_TIC_TIC x0' x1' x2' >>= wrapReturn

-- classy wrapper
ioInterfaceFX_setOutput'''''''' :: IOInterfaceFXClass a => a -> DMatrix -> String -> IO ()
ioInterfaceFX_setOutput'''''''' x = casADi__IOInterface_CasADi__FX___setOutput'''''''' (castIOInterfaceFX x)

