{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.PrintableObject
       (
         PrintableObject,
         PrintableObjectClass(..),
         printableObject_getDescription,
         printableObject_getRepresentation,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show PrintableObject where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__PrintableObject__getRepresentation" c_CasADi__PrintableObject__getRepresentation
  :: Ptr PrintableObject' -> IO (Ptr StdString')
casADi__PrintableObject__getRepresentation
  :: PrintableObject -> IO String
casADi__PrintableObject__getRepresentation x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__PrintableObject__getRepresentation x0' >>= wrapReturn

-- classy wrapper
{-|
>Return a string with a representation (for SWIG)
-}
printableObject_getRepresentation :: PrintableObjectClass a => a -> IO String
printableObject_getRepresentation x = casADi__PrintableObject__getRepresentation (castPrintableObject x)


-- direct wrapper
foreign import ccall unsafe "CasADi__PrintableObject__getDescription" c_CasADi__PrintableObject__getDescription
  :: Ptr PrintableObject' -> IO (Ptr StdString')
casADi__PrintableObject__getDescription
  :: PrintableObject -> IO String
casADi__PrintableObject__getDescription x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__PrintableObject__getDescription x0' >>= wrapReturn

-- classy wrapper
{-|
>Return a string with a destription (for SWIG)
-}
printableObject_getDescription :: PrintableObjectClass a => a -> IO String
printableObject_getDescription x = casADi__PrintableObject__getDescription (castPrintableObject x)

